
/*
 *This file includes the implementation of the functions to operate on NeighborEntry arrays
 */

#include "neighbor.h"
 
/*Order a Neighbor array*/
void order (NeighborEntry* table1, int dimension)
{
   int swapflag=0;
   int loop=0;
   int MAX=dimension;
   NeighborEntry temp;
   
   /*Bubble sort the table*/
   do
     {
      swapflag=0;
      for(loop=0; loop<MAX-1;loop++)
        {
          if(table1[loop]<table1[loop+1])
      	    {
	            temp=table1[loop];
	            table1[loop]=table1[loop+1];
      	      table1[loop+1]=temp;
      	      swapflag=1;
	          }
        }
     }   while (swapflag!=0);
}

/*Check if a NeighborEntry is present in a Neighbor array*/
int belongs(NeighborEntry* table, int dim, NeighborEntry en)
{
  int j=0;
  for (j=0;j<dim; j++)
    if (table[j]==en) return (1);
	return (0);
}

 






/*=========================================================================================================*/
/*==============        > OPERATOR OVERLOADING FOR NEIGHBOR ENTRIES              ==========================*/
/*=========================================================================================================*/

bool operator < (NeighborEntry& e1, NeighborEntry& e2)
{
 bool t1;
 bool res=t1;
 if (e1.neigh_num < e2.neigh_num) return (res=true);
 else if (e2.neigh_num < e1.neigh_num) return (res=false);
 else return (e1.id<e2.id?res=false:res=true);
}

/*=========================================================================================================*/
/*==============        == OPERATOR OVERLOADING FOR NEIGHBOR ENTRIES              ==========================*/
/*=========================================================================================================*/

bool operator == (NeighborEntry& e1, NeighborEntry& e2)
{
 bool res;
 if (e1.id == e2.id) return (res=true);
 else  return (res=false);
}


